// Datei: dltest.c
// PIC16F84 steuert LED-Display DL1416
//
// Der PIC zeigt alle darstellbaren Zeichen an der Stelle
// ganz links, und rechts daneben den Zeichencode in HEX
// fr jeweils 2s an.
//
// Der Zeichensatz vom DL1416 geht nur von 0x20-0x5F
// Das sind die Zahlen 0-9, alle Grobuchstaben und
// ein paar andere Zeichen wie +,-,*,? usw.
// Kleinbuchstaben sind nicht enthalten !
// Die Zeichencodes entsprechen dem ASCII-Zeichensatz
//
// Schreibt man Zeichencodes < 0x20 oder > 0x5F ins
// Display, wird die entsprechende Stelle gelscht.
//
// hk@holger-klabunde.de
// www.holger-klabunde.de
// 15.03.2002
// Compiler CC5x

#include "prozess.h"      // Der verwendete Prozessor
#include "dltest.h"
#include "protos.h"

#include "delay.c"
#include "dl1416.c"
 
//*******************************************************
// Hauptprogramm
//*******************************************************
void main()
{
 unsigned char i,by;
 
 CLRWDT;
 //Takt des PIC 4MHz, ein Zyklus = 1us
 OPTION=0b11000001; //Pullups off,Prescaler auf TMR0, 1:4

 TRISB=0b00000000;  //0=Ausgang, 1=Eingang
 PORTB=0b00000000;  //Port einmal schreiben

 TRISA=0b10000;     //0=Ausgang, 1=Eingang
 PORTA=0b00111;     //Port einmal schreiben
 
 Delay1ms(255); //Warten auf PowerUp

 DLCls(); //Sollte besser DLInit() heien ;)

 DLWrite("HOLG");
 for(i=0; i<8; i++) Delay1ms(250); //Warte ca. 2s 

 DLPos(2);
 DLWriteByte('=');

 by=0x20; //Beginn des Zeichensatzes
 
 while(1) // Programm-Endlosschleife
  {
   DLPos(1);
   DLWriteByte(by);

   DLPos(3);
   DLShowHex(by);
   for(i=0; i<8; i++) Delay1ms(250); //Warte ca. 2s

   by++;
   if(by>0x5F) by=0x20; //Zeichensatz geht nur von 0x20 bis 0x50
  } //while(1) Endlosschleife

}
